'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tmpPromise = require('tmp-promise');
var fsExtra = require('fs-extra');
var kexec = _interopDefault(require('kexec'));

class Terminal {
  async apply(flow) {
    const app = flow.children[0];

    const script = await app.open(app, { platform: 'osx', wm: 'terminal' }, app.children);

    const { path, fd } = await tmpPromise.file({
      prefix: 'workflow-wm-terminal-',
      postfix: '.sh',
      mode: 0o755
    });

    await fsExtra.outputFile(path, script);
    await fsExtra.close(fd);

    kexec(path);
  }

  async screen() {
    return {
      left: 0,
      top: 0,
      width: 1024,
      height: 768
    };
  }
}

module.exports = Terminal;
